OGRE: Ogre::SmallVector< T, N > Class Template Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::SmallVector< T, N > Class Template Reference

SmallVector - This is a 'vector' (really, a variable-sized array), optimized for the case when the array is small. More...

`#include <OgreSmallVector.h>`

Inheritance diagram for Ogre::SmallVector< T, N >:
[legend]

## Public Member Functions
| SmallVector ()
| SmallVector (const SmallVector &RHS)
template<typename ItTy>
| SmallVector (ItTy S, ItTy E)
| SmallVector (unsigned Size, const T &Value=T())
const SmallVector & | operator= (const SmallVector &RHS)
Public Member Functions inherited from Ogre::SmallVectorImpl< T >
| SmallVectorImpl (unsigned N)
| ~SmallVectorImpl ()
template<typename in_iter>
void | append (in_iter in_start, in_iter in_end)
| append - Add the specified range to the end of the SmallVector.
void | append (size_type NumInputs, const T &Elt)
| append - Add the specified range to the end of the SmallVector.
void | assign (unsigned NumElts, const T &Elt)
void | clear ()
iterator | erase (iterator I)
iterator | erase (iterator S, iterator E)
iterator | insert (iterator I, const T &Elt)
template<typename ItTy>
iterator | insert (iterator I, ItTy From, ItTy To)
iterator | insert (iterator I, size_type NumToInsert, const T &Elt)
bool | operator!= (const SmallVectorImpl &RHS) const
bool | operator< (const SmallVectorImpl &RHS) const
const SmallVectorImpl & | operator= (const SmallVectorImpl &RHS)
bool | operator== (const SmallVectorImpl &RHS) const
void | pop_back ()
T | pop_back_val ()
void | push_back (const T &Elt)
void | reserve (unsigned N)
void | resize (unsigned N)
void | resize (unsigned N, const T &NV)
void | set_size (unsigned N)
| set_size - Set the array size to
void | swap (SmallVectorImpl &RHS)
Public Member Functions inherited from Ogre::SmallVectorTemplateBase< T, isPodLike< T >::value >
| SmallVectorTemplateBase (size_t Size)
void | grow (size_t MinSize=0)
| grow - double the size of the allocated memory, guaranteeing space for at least one more element or MinSize if specified.
Public Member Functions inherited from Ogre::SmallVectorTemplateCommon< T >
| SmallVectorTemplateCommon (size_t Size)
reference | back ()
const_reference | back () const
iterator | begin ()
const_iterator | begin () const
size_t | capacity () const
| capacity - Return the total number of elements in the currently allocated buffer.
pointer | data ()
| data - Return a pointer to the vector's buffer, even if empty().
const_pointer | data () const
| data - Return a pointer to the vector's buffer, even if empty().
iterator | end ()
const_iterator | end () const
reference | front ()
const_reference | front () const
size_type | max_size () const
reference | operator[] (unsigned idx)
const_reference | operator[] (unsigned idx) const
reverse_iterator | rbegin ()
const_reverse_iterator | rbegin () const
reverse_iterator | rend ()
const_reverse_iterator | rend () const
size_type | size () const
Public Member Functions inherited from Ogre::SmallVectorBase
bool | empty () const

## Additional Inherited Members
Public Types inherited from Ogre::SmallVectorImpl< T >
typedef SuperClass::iterator | iterator
typedef SuperClass::size_type | size_type
Public Types inherited from Ogre::SmallVectorTemplateCommon< T >
typedef const T * | const_iterator
typedef const T * | const_pointer
typedef const T & | const_reference
typedef std::reverse_iterator< const_iterator > | const_reverse_iterator
typedef ptrdiff_t | difference_type
typedef T * | iterator
typedef T * | pointer
typedef T & | reference
typedef std::reverse_iterator< iterator > | reverse_iterator
typedef size_t | size_type
typedef T | value_type
Static Public Member Functions inherited from Ogre::SmallVectorTemplateBase< T, isPodLike< T >::value >
static void | destroy_range (T *S, T *E)
static void | uninitialized_copy (It1 I, It1 E, It2 Dest)
| uninitialized_copy - Copy the range [I, E) onto the uninitialized memory starting with "Dest", constructing elements into it as needed.

## Detailed Description

template<typename T, unsigned N>
class Ogre::SmallVector< T, N >

SmallVector - This is a 'vector' (really, a variable-sized array), optimized for the case when the array is small.

It contains some number of elements in-place, which allows it to avoid heap allocation when the actual number of elements is below that threshold. This allows normal "small" cases to be fast without losing generality for large inputs.

Note that this does not attempt to be exception safe.

## Constructor & Destructor Documentation

## ◆ SmallVector() [1/4]

template<typename T, unsigned N>

Ogre::SmallVector< T, N >::SmallVector | ( |  | ) |
| inline

## ◆ SmallVector() [2/4]

template<typename T, unsigned N>

Ogre::SmallVector< T, N >::SmallVector | ( | unsigned | Size,
|  | const T & | Value = T() )
| inlineexplicit

## ◆ SmallVector() [3/4]

template<typename T, unsigned N>
template<typename ItTy>

Ogre::SmallVector< T, N >::SmallVector | ( | ItTy | S,
|  | ItTy | E )
| inline

## ◆ SmallVector() [4/4]

template<typename T, unsigned N>

Ogre::SmallVector< T, N >::SmallVector | ( | const SmallVector< T, N > & | RHS | ) |
| inline

## Member Function Documentation

## ◆ operator=()

template<typename T, unsigned N>

const SmallVector & Ogre::SmallVector< T, N >::operator= | ( | const SmallVector< T, N > & | RHS | ) |
| inline

The documentation for this class was generated from the following file:

- OgreSmallVector.h